VERSION 5.00
Begin VB.UserControl UrlLabel 
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   390
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   420
   MouseIcon       =   "urllabel.ctx":0000
   MousePointer    =   99  'Custom
   ScaleHeight     =   390
   ScaleWidth      =   420
   Begin VB.Label lblText 
      Enabled         =   0   'False
      Height          =   315
      Left            =   30
      TabIndex        =   0
      Top             =   45
      Width           =   4095
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "UrlLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' URLLabel written by David Crowell (davidc@qtm.net)
' See http://www.qtm.net/~davidc for updates
' Released into the public domain, since I believe that trying to sell such
' a simple piece of work would be silly.  Use this code at your own risk,
' modify as you wish.
'

' ID is used to identify this instance of the control to MurlTimer
Private ID As Long

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Properties
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Property member variables
Private mBackColor As OLE_COLOR
Private mNormTextColor As OLE_COLOR
Private mHoverTextColor As OLE_COLOR
Private mNormUnderline As Boolean
Private mHoverUnderline As Boolean
Private mFont As StdFont
Private mCaption As String
Private mURL As String
Private mEnabled As Boolean
Private mCheckHover As Boolean
'Default Property Values:
Const m_def_BackColorNorm = &HC0C0C0
Const m_def_BackColorHover = vbBlue
'Property Variables:
Dim m_BackColorNorm As OLE_COLOR
Dim m_BackColorHover As OLE_COLOR

Enum t_Alignment
    Left = 0
    Right = 1
    Midle = 2
End Enum


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get NormTextColor() As OLE_COLOR
Attribute NormTextColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute NormTextColor.VB_UserMemId = -513
    NormTextColor = mNormTextColor
End Property
Public Property Let NormTextColor(NewColor As OLE_COLOR)
    mNormTextColor = NewColor
    lblText.ForeColor = NewColor
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get HoverTextColor() As OLE_COLOR
Attribute HoverTextColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HoverTextColor = mHoverTextColor
End Property
Public Property Let HoverTextColor(NewColor As OLE_COLOR)
    mHoverTextColor = NewColor
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get NormUnderline() As Boolean
    NormUnderline = mNormUnderline
End Property
Public Property Let NormUnderline(val As Boolean)
    mNormUnderline = val
    lblText.FontUnderline = val
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get HoverUnderline() As Boolean
Attribute HoverUnderline.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HoverUnderline = mHoverUnderline
End Property
Public Property Let HoverUnderline(val As Boolean)
    mHoverUnderline = val
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Font.VB_UserMemId = -512
    Set Font = mFont
End Property
Public Property Set Font(NewFont As StdFont)
    Set mFont = NewFont
    Set lblText.Font = mFont
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Caption() As String
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Caption.VB_UserMemId = -518
    Caption = mCaption
End Property
Public Property Let Caption(val As String)
    mCaption = val
    lblText.Caption = val
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get URL() As String
Attribute URL.VB_ProcData.VB_Invoke_Property = ";Behavior"
    URL = mURL
End Property
Public Property Let URL(val As String)
    mURL = val
    lblText.ToolTipText = val
End Property

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_UserMemId = -514
    Enabled = mEnabled
End Property
Public Property Let Enabled(val As Boolean)
    mEnabled = val
    lblText.Enabled = val
    UserControl.Enabled = val
    CheckRegister
End Property
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Property Get CheckHover() As Boolean
    CheckHover = mCheckHover
End Property
Public Property Let CheckHover(val As Boolean)
    mCheckHover = val
    CheckRegister
End Property

Private Sub lblText_Click()
On Error Resume Next
If URL <> "" Then
    Call ShellExecute(0&, vbNullString, URL, vbNullString, vbNullString, vbNormalFocus)
End If
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' set up the default values
Private Sub UserControl_InitProperties()
    Set Font = Ambient.Font
'    BackColor = Ambient.BackColor
    NormTextColor = Ambient.ForeColor
    HoverTextColor = Ambient.ForeColor
    URL = ""
    Enabled = True
    Caption = "URL Label"
    NormUnderline = False
    HoverUnderline = False
    CheckHover = True
    m_BackColorNorm = m_def_BackColorNorm
    m_BackColorHover = m_def_BackColorHover
    lblText.BackColor = m_def_BackColorNorm
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
' Read saved properties
    On Error Resume Next
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    BackColor = PropBag.ReadProperty("BackColor", Ambient.BackColor)
    NormTextColor = PropBag.ReadProperty("NormTextColor", Ambient.ForeColor)
    HoverTextColor = PropBag.ReadProperty("HoverTextColor", Ambient.ForeColor)
    URL = PropBag.ReadProperty("URL", "explorer c:\")
    Enabled = PropBag.ReadProperty("Enabled", True)
    Caption = PropBag.ReadProperty("Caption", "URL Label")
    NormUnderline = PropBag.ReadProperty("NormUnderline", False)
    HoverUnderline = PropBag.ReadProperty("HoverUnderline", True)
    CheckHover = PropBag.ReadProperty("CheckHover", True)
    m_BackColorNorm = PropBag.ReadProperty("BackColorNorm", m_def_BackColorNorm)
    m_BackColorHover = PropBag.ReadProperty("BackColorHover", m_def_BackColorHover)
    lblText.Alignment = PropBag.ReadProperty("Alignment", 0)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
' Write properties (used only during design time)
    PropBag.WriteProperty "Font", Font
    PropBag.WriteProperty "BackColor", BackColor, Ambient.BackColor
    PropBag.WriteProperty "NormTextColor", NormTextColor, Ambient.ForeColor
    PropBag.WriteProperty "HoverTextColor", HoverTextColor, Ambient.ForeColor
    PropBag.WriteProperty "URL", URL, ""
    PropBag.WriteProperty "Enabled", Enabled, True
    PropBag.WriteProperty "Caption", Caption, "URL Label"
    PropBag.WriteProperty "NormUnderline", NormUnderline, False
    PropBag.WriteProperty "HoverUnderline", HoverUnderline, True
    PropBag.WriteProperty "CheckHover", CheckHover, True
    Call PropBag.WriteProperty("BackColorNorm", m_BackColorNorm, m_def_BackColorNorm)
    Call PropBag.WriteProperty("BackColorHover", m_BackColorHover, m_def_BackColorHover)
    Call PropBag.WriteProperty("Alignment", lblText.Alignment, 0)
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub UserControl_Resize()
' the label should stay the same size as the usercontrol
    lblText.Move 0, 0, UserControl.Width, UserControl.Height
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Public Sub TimerProc()
' This sub is called from the timer callback in MurlTimer to check
' mouse position
    On Error Resume Next
    Dim CurPos As POINTAPI
    Dim WndRct As RECT
    
    ' find the location of the control
    Call GetWindowRect(UserControl.hwnd, WndRct)
    ' find the cursor
    Call GetCursorPos(CurPos)
    ' is it over the control?
    If CurPos.x > WndRct.Left And CurPos.x < WndRct.Right And _
        CurPos.y > WndRct.Top And CurPos.y < WndRct.Bottom Then
        
        ' if so change the appearance as necessary
        If lblText.FontUnderline <> mHoverUnderline Then lblText.FontUnderline = mHoverUnderline
        If lblText.ForeColor <> mHoverTextColor Then lblText.ForeColor = mHoverTextColor
        If lblText.BackColor <> m_BackColorHover Then lblText.BackColor = m_BackColorHover
    Else
        ' if not restore the original if necessary
        If lblText.FontUnderline <> mNormUnderline Then lblText.FontUnderline = mNormUnderline
        If lblText.ForeColor <> mNormTextColor Then lblText.ForeColor = mNormTextColor
        If lblText.BackColor <> m_BackColorNorm Then lblText.BackColor = m_BackColorNorm
    End If
    
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub CheckRegister()
' Determine if we need to register or unregister
' (registering enables a timer for this control)
    Register mEnabled And mCheckHover And Ambient.UserMode And (ID = 0)
End Sub
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub Register(yes As Boolean)
' True = Hook a timer event
    If yes Then
        If Not ID Then
            ' always make sure we don't hook more than once
            ID = AddClient(Me)
        End If
' False = Unhook timer
    Else
        ' restore normal setting if necessary
        If lblText.FontUnderline <> mNormUnderline Then lblText.FontUnderline = mNormUnderline
        If lblText.ForeColor <> mNormTextColor Then lblText.ForeColor = mNormTextColor
'        If lblText.BackColor <> m_BackColorNorm Then lblText.BackColor = m_BackColorNorm
        If ID Then
            ' don't unhook if we're not hooked
            RemoveClient ID
            ID = 0
        End If
    End If
End Sub

Private Sub UserControl_Terminate()
' Unhook the timer
    Register False
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColorNorm() As OLE_COLOR
Attribute BackColorNorm.VB_Description = "    "
    BackColorNorm = m_BackColorNorm
End Property

Public Property Let BackColorNorm(ByVal New_BackColorNorm As OLE_COLOR)
    m_BackColorNorm = New_BackColorNorm
    lblText.BackColor = m_BackColorNorm
    PropertyChanged "BackColorNorm"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get BackColorHover() As OLE_COLOR
Attribute BackColorHover.VB_Description = "      "
    BackColorHover = m_BackColorHover
End Property

Public Property Let BackColorHover(ByVal New_BackColorHover As OLE_COLOR)
    m_BackColorHover = New_BackColorHover
    PropertyChanged "BackColorHover"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblText,lblText,-1,Alignment
Public Property Get Alignment() As t_Alignment
Attribute Alignment.VB_Description = "/     ,   ."
    Alignment = lblText.Alignment
End Property

Public Property Let Alignment(ByVal New_Alignment As t_Alignment)
    lblText.Alignment() = New_Alignment
    PropertyChanged "Alignment"
End Property

